## net.sf.saxon.functions
Class Minimax

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.functions.SystemFunction
                  net.sf.saxon.functions.CollatingFunction
                      net.sf.saxon.functions.Minimax

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public class Minimax

extends CollatingFunction

This class implements the min() and max() functions

See Also:
  Serialized Form

Field Summary
`static int` `MAX`
`static int` `MIN`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`Minimax()`

Method Summary
`void` `checkArguments(StaticContext env)` Static analysis: prevent sorting of the argument
`int` `computeCardinality()` Determine the cardinality of theV function.
`Item` `evaluateItem(XPathContext context)` Evaluate the function
`ItemType` `getItemType(TypeHierarchy th)` Determine the item type of the value returned by the function
`boolean` `isIgnoreNaN()` Test whether NaN values are to be ignored
`static AtomicValue` `minimax(SequenceIterator iter, int operation, AtomicComparer atomicComparer, boolean ignoreNaN, XPathContext context)` Static method to evaluate the minimum or maximum of a sequence
`Expression` `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`void` `setIgnoreNaN(boolean ignore)` Indicate whether NaN values should be ignored.

Methods inherited from class net.sf.saxon.functions.CollatingFunction
`getExpressionBaseURI, getStringCollator`

Methods inherited from class net.sf.saxon.functions.SystemFunction
`computeSpecialProperties, display, getDetails, getErrorCodeForTypeErrors, main, makeSystemFunction, setDetails`

Methods inherited from class net.sf.saxon.expr.FunctionCall
`getArguments, getDisplayName, getFunctionNameCode, getNumberOfArguments, iterateSubExpressions, preEvaluate, promote, replaceSubExpression, setArguments, setFunctionNameCode, simplify, typeCheck`

Methods inherited from class net.sf.saxon.expr.Expression

`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, iterate, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### MIN

    public static final int MIN

See Also:
  Constant Field Values

### MAX

    public static final int MAX

See Also:
  Constant Field Values

Constructor Detail

### Minimax

    public Minimax()

Method Detail

### setIgnoreNaN

    public void setIgnoreNaN(boolean ignore)

  Indicate whether NaN values should be ignored. For the external min() and max() function, a NaN value in the input causes the result to be NaN. Internally, however, min() and max() are also used in such a way that NaN values should be ignored.

  Parameters:
    `ignore` - true if NaN values are to be ignored when computing the min or max.

### isIgnoreNaN

    public boolean isIgnoreNaN()

  Test whether NaN values are to be ignored

### checkArguments

    public void checkArguments(StaticContext env)
                        throws XPathException

  Static analysis: prevent sorting of the argument

  Overrides:
    `checkArguments` in class `CollatingFunction`
  Throws:
    `XPathException`

### computeCardinality

    public int computeCardinality()

  Determine the cardinality of theV function.

  Overrides:
    `computeCardinality` in class `SystemFunction`

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `SystemFunction`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the item type of the value returned by the function

  Overrides:
    `getItemType` in class `SystemFunction`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the statically inferred type of the expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the function

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### minimax

    public static AtomicValue minimax(SequenceIterator iter,
                                      int operation,
                                      AtomicComparer atomicComparer,
                                      boolean ignoreNaN,
                                      XPathContext context)
                               throws XPathException

  Static method to evaluate the minimum or maximum of a sequence

  Parameters:
    `iter` - Iterator over the input sequence
    `operation` - either `MIN` or `MAX`
    `atomicComparer` - an AtomicComparer used to compare values
    `ignoreNaN` - true if NaN values are to be ignored
    `context` - dynamic evaluation context
  Returns:
    the min or max value in the sequence, according to the rules of the fn:min() or fn:max() functions
  Throws:
    `XPathException` - typically if non-comparable values are found in the sequence

Copyright (C) Michael H. Kay. All rights reserved.